#!/usr/bin/env python

class C:
    def h(self):
        self.m = self.f
        return self.m # not known
    def f(self): pass

    def test(self):
        self.f()
        self.h()

class D:
    f = C.f
    def h(self):
        self.m = self.f
        return self.m # not known

    def test(self):
        self.f(2)
        self.h()

class E(C):
    def h(self):
        self.m = self.f
        return self.m # not known

    def test(self):
        self.f()
        self.h()

c = C()
d = D()
e = E()

x = c.f # bound C.f   == c.h()
y = d.f # unbound C.f == d.h()
z = e.f # bound E.f   == e.h()

# vim: tabstop=4 expandtab shiftwidth=4
